package easik.database.types;

//~--- non-JDK imports --------------------------------------------------------

//~--- JDK imports ------------------------------------------------------------
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Types;

import easik.xml.xsd.nodes.types.XSDBaseType;
import easik.xml.xsd.nodes.types.XSDType;

/**
 * A class representing a TEXT SQL data type.  A TEXT can store an unlimited
 * amount of text data (though some base impose a limit--for example, the
 * maximum size under MySQL is 4GB).  This type will be mapped to the largest
 * text type supported by the db (under MySQL, BIGTEXT; under most other
 * databases, TEXT).
 */
public class Text extends EasikType
{
    /**
     *
     *
     * @return
     */
    public String toString()
    {
        return "TEXT";
    }

    /**
     *
     *
     * @param input
     *
     * @return
     */
    public boolean verifyInput(final String input)
    {
        return true;
    }

    /**
     *
     *
     * @return
     */
    public int getSqlType()
    {
        return Types.CLOB;
    }    // FIXME??

    /**
     *
     *
     * @param ps
     * @param col
     * @param value
     *
     * @throws SQLException
     */
    public void bindValue(final PreparedStatement ps, final int col, final String value) throws SQLException
    {
        ps.setString(col, value);
    }

    /**
     *
     *
     * @return
     */
    public XSDType getXMLSchemaType()
    {
        return XSDBaseType.xsString;
    }
}
